#include <qapplication.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include "klasse.h"

MeinWidget::MeinWidget (QWidget *parent=0, const char*name = 0)
  : QWidget (parent, name)
{
  NumberOf = 0;

  p = new QPushButton (this);
  Q_CHECK_PTR (p);

  p->setGeometry (0, 0, width () , height () / 2);
  p->setText (QString::number (NumberOf));

  connect ( p, SIGNAL (clicked()),  this, SLOT (slot_clicked()) );
  connect ( this, SIGNAL (sig_signal(int)),  this, SLOT (slot_output(int)) );

  slot_output (NumberOf);
}

void MeinWidget::slot_clicked (void)
{
  NumberOf++;
  emit sig_signal (NumberOf);
}

void MeinWidget::slot_output (int x)
{
  QString s = "Dieser Button wurde " + QString::number (x) +
    "-Mal aufgerufen";
  p->setText (s);
}

int main( int argc, char **argv )
{
    QApplication a( argc, argv );
    MeinWidget *hallo = new MeinWidget;
    a.setMainWidget( hallo );
    hallo->setCaption ("Zaehlen - Knopf");
    hallo->show();
    return a.exec();
}
