#include <qapplication.h>
#include "klasse.h"

Maus::Maus (double x, double y)
{
  xPos = (double) x;
  yPos = (double) y;
  NeuX = (double) x;
  NeuY = (double) y;
}

double Maus::getMausX (void)
{
  return xPos;
}

double Maus::getMausY (void)
{
  return yPos;
}

void Maus::calcNewPos (double OtherX, double OtherY)
{
  NeuX = xPos + 0.04 * (OtherX - xPos);
  NeuY = yPos + 0.04 * (OtherY - yPos);
}

void Maus::setNewPos (void)
{
  xPos = NeuX;
  yPos = NeuY;
}



MeinWidget::MeinWidget (QWidget *parent=0, const char*name = 0)
  : QWidget (parent, name)
{
  // Groessenbeschraenkung
  setMinimumSize (500, 500);
  setMaximumSize (500, 500);
  
  // Button einfuegen...
  p = new QPushButton (this);
  p->setGeometry (width () - 20, height() - 20, 20, 20);
  // ... und mit start_timer () verbinden
  connect (p, SIGNAL (clicked ()), this, SLOT (start_timer ()) );

  // Hintergrundfarbe setzen: geht auch anders!
  setPaletteBackgroundColor (QColor (100, 100, 100));

  // Maeuse erzeugen
  maeuse[5] = new Maus (width () / 2, 10);
  maeuse[3] = new Maus (10, height () / 3);
  maeuse[1] = new Maus (10, height () * 2 / 3);
  maeuse[4] = new Maus (width () / 2, height () - 20);
  maeuse[2] = new Maus (width () - 20, height () * 2 / 3);
  maeuse[0] = new Maus (width () - 20, height () / 3);

  NumMaeuse = 6;

  t = new QTimer (this);
  connect (t, SIGNAL (timeout ()), this, SLOT (maus_update ()));
}

void MeinWidget::maus_update (void)
{
  int i, mn;
  
  // Neu zeichnen
  QPainter paint (this);
  paint.moveTo (
    (int) maeuse[NumMaeuse-1]->getMausX (), 
    (int) maeuse[NumMaeuse-1]->getMausY ());
  for (i = 0; i < NumMaeuse; i++)
    {
      // Setze Farben (red, green und blue vordefinierte Konstanten)
      if ((i+1) % 3 == 0)
        paint.setPen (red);
      else if ((i+1) % 3 == 1)
        paint.setPen (green);
      else
        paint.setPen (blue);

      paint.lineTo (
        (int) maeuse[i]->getMausX (), 
        (int) maeuse[i]->getMausY ());
    }

  // Neue Positionen aus den alten Positionen berechnen
  for (i = 0; i < NumMaeuse; i++)
    {
      // Meint: naechste Maus! (ja, geht auch mit Modulo "%",
      // ich wei!)
      mn = i+1;
      if (mn == NumMaeuse) mn = 0;

      maeuse[i]->calcNewPos (
        maeuse[mn]->getMausX (),
        maeuse[mn]->getMausY ());
    }

  // Neue Position aller Maeuse uebernehmen  
  for (i = 0; i < NumMaeuse; i++)
    maeuse[i]->setNewPos ();
}

void MeinWidget::start_timer (void)
{
  if (t->isActive ())
    t->stop ();
  else
    t->start (100);
}

int main( int argc, char **argv )
{
    QApplication a( argc, argv );
    MeinWidget *hallo = new MeinWidget;
    a.setMainWidget( hallo );
    hallo->setCaption ("Die Maeuse!");
    hallo->show();
    return a.exec();
}
